routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


// Auth::routes();

//Login Admin//
Route::group(['prefix' => '/'], function () {
    Route::get('/', function () {
        return view('index');
    });
    Route::get('login', 'LoginController@index')->name('login');
    Route::get('logout', 'LoginController@logout');
    Route::post('validate-login', 'LoginController@login');
});

Route::get('/home', 'HomeController@index');
 Route::resource('modul', 'ModulsController')->middleware('verify-login');

// Pengguna //
Route::group(['prefix' => 'user', 'middleware' => 'verify-login'], function () {
    Route::get('/', 'UserController@index');
    Route::post('/form', 'UserController@create');
    Route::post('/save', 'UserController@save');
    Route::post('/delete', 'UserController@delete');
});


// Modul //
Route::group(['prefix' => 'moduls',  'middleware' => 'verify-login'], function () {
    Route::get('/', 'ModulsController@index');
    Route::get('/create', 'ModulsController@store');
    Route::post('/delete', 'ModulsController@destroy');
    Route::get('/{id}/edit','ModulsController@edit');
    Route::put('/list/{id}','ModulsController@update');
    Route::delete('/list/{id}','ModulsController@destroy');
    Route::post('/delete-gambar/{id}','ModulsController@deleteGambar');
});

// Video //
Route::group(['prefix' => 'video', 'middleware' => 'verify-login'], function () {
    Route::get('/', 'VideoController@index');
    Route::get('/add', 'VideoController@create');
    Route::post('/save', 'VideoController@store');
    Route::get('/edit/{id}','VideoController@edit');
    Route::post('/update/{id}','VideoController@update');
    Route::delete('/delete/{id}','VideoController@destroy');
   

    // Route::post('/save', 'VideoController@save');
    // Route::post('/delete', 'VideoController@delete');
});

app/Modul.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
// use Illuminate\Support\Facades\DB;
// use Illuminate\Database\Query\Builder;
// use Illuminate\Http\Request;
// use App\Gambar;

class Modul extends Model
{
    protected $table = 'moduls';
    protected $fillable = ['bab','judul','sumber', 'konten'];
    public $timestamps = true;

    public function gambar()
    {
        return $this->hasMany('App\Gambar', 'id_modul', 'id');
    }

}

app/Http/Controllers/ModulsController.php
<?php

namespace App\Http\Controllers;

use App\Modul;
use App\Gambar;
use Validator;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\Storage;
use Session;

class ModulsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $modul = Modul::all();
        return view('admin.modul.list', ['modul' => $modul]);

    }

    // *
    //  * Show the form for creating a new resource.
    //  *
    //  * @return \Illuminate\Http\Response
     
    public function create()
    {
        $modul= modul::all();
        return view('admin.modul.form');

    }

    // *
    //  * Store a newly created resource in storage.
    //  *
    //  * @param  \Illuminate\Http\Request  $request
    //  * @return \Illuminate\Http\Response
     
    public function store(Request $request)
    {
        // //$input = $request->file('file');
        // $file = $request->file('file'); 
        // // $extension = $file->getClientOriginalExtension(); 

        // $input = $request->all();
        // $input['file'] = time().'.'.$extension;
        // $request->file->move(public_path('upload'), $input['file']);

        // Modul::create($input);

        // return redirect()->route('modul.index')->with('alert-success','Berhasil Menambahkan Data!');
        $documentFiles=$request->file('file');
        $modul = new Modul;
        $modul->judul = $request->judul;
        $modul->sumber= $request->sumber;
        $modul->konten = $request->konten;
        $modul->save(); 

    
        
        $allowedfileExtension=['bmp','jpg','png','jpeg'];
        if ($documentFiles) {
            foreach ($documentFiles as $key=>$file) {
                $extension = strtolower($file->getClientOriginalExtension());
                $rand = str_random(5);
                $check=in_array($extension,$allowedfileExtension);
                if ($check) {
                    $gambar = new Gambar();
                    $gambar->id_modul= $modul->id;
                    $filename = $rand.$file->getClientOriginalName();
                    $gambar->nama_file = $file->storeAs('public/images', $filename);
                    $gambar->save(); 
                }
            }
        }
        
        return redirect('/moduls');

    }

    public function edit($id)
    {
        $modul = Modul::find($id);
        $gambar = Gambar::query()->where("id_modul", $id)->get();
        $modul->konten = str_ireplace("\n", "<br>", $modul->konten);                           
        return view('admin.modul.edit', ['modul' => $modul, 'gambar' => $gambar]);

    }

    public function update(Request $request, $id)
    {
        $request->konten = trim($request->konten, "");
        $request->validate([
            'judul' => 'required',
            'sumber' => 'required',
            'konten' => 'required',
        ]);
        $modul = Modul::find($id);

        
        $modul->judul = $request->judul;
        $modul->sumber= $request->sumber;
        $modul->konten = $request->konten;
        $modul->save();

        $documentFiles=$request->file('file');
        $fileLama=$request->filename;
        $checkGambarLama=$this->checkGambar($fileLama,$id);

    
        $allowedfileExtension=['bmp','jpg','png','jpeg'];
        if ($documentFiles) {
            foreach ($documentFiles as $key=>$file) {
                $rand = str_random(5);
                $extension = strtolower($file->getClientOriginalExtension());
                $check=in_array($extension,$allowedfileExtension);
                $checkLamaBaru=$this->checkGambarLamaBaru($checkGambarLama,$file->getClientOriginalName());
                if($check){
                    if($checkLamaBaru!=false){
                        $value1=explode('-',$checkLamaBaru);
                        $checkGambar=Gambar::find($value1[0]);
                        $filename = $rand.$file->getClientOriginalName();
                        $checkGambar->nama_file = $file->storeAs('public/images', $filename);
                        $checkGambar->save(); 
                    }else{
                        $gambar = new Gambar();
                        $gambar->id_modul= $id;
                        $filename = $rand.$file->getClientOriginalName();
                        $gambar->nama_file = $file->storeAs('public/images', $filename);
                        $gambar->save(); 
                    }
                }
               
            
        
            }
        }
        return redirect('/moduls')->with('alert-success','Berhasil Memperbarui!'); 
    }

    private function checkGambar($gambar,$id)
    {
        $currentData=[];
        $gambarLama=Gambar::where("id_modul", $id)->get();
        foreach($gambarLama as $key1 =>$item1){
            $namaFile=str_replace('public/images/','',$item1->nama_file);
            if($gambar[$key1]!=$namaFile){
                $currentData[]=[
                    'id'=>$item1->id,
                    'gambar_baru'=>$gambar[$key1]
                ];
            }
        }

        return $currentData;

    }

    private function checkGambarLamaBaru($gambar,$fileUpload)
    {
        foreach($gambar as $key =>$item)
        {
            if($gambar[$key]['gambar_baru']==$fileUpload){
                return $gambar[$key]['id'].'-'.$gambar[$key]['gambar_baru'];
            }else{
                return false;
            }
        }

    }
      
    public function destroy($id)
    {
         $modul = modul::find($id);
         $gambar = gambar::find($id);
         $modul -> delete();
        return redirect('/moduls')->with('alert-success','Berhasil Menghapus Data!'); 
    }

    public function get()
    {
        $modul = new Modul;
        $modul->results= Modul::all();

        
        return response()
            ->json($modul->result, 200);
    }


    public function get_judul(){
        // $modul = new Modul;
        // $modul->request = Modul::all();
        $modul = Modul::all();
        $data = Gambar::join('moduls','gambar.id_modul','=','moduls.id')->get();
        return response()->json($modul,200);

        // $judul = (object)["results" => []];
        // foreach ($modul->results as $value) {
        //     $data = (object)array("id"=>$value->id, "judul"=>$value->judul);
        //     array_push($judul->results, $data);
        // }
        // return response()->json($judul, 200);
    }
    public function get_id($id){
        // $modul = new modul;
        // $modul->result = modul::find($id);
        $data = Modul::with('gambar')->find($id);
        return response()->json($data, 200);
    }

    public function deleteGambar($id)
    {
        Gambar::find($id)->delete();
    }
}

resources/views/admin/modul/edit.blade.php
@extends('partials._design')

@section('content')
<script type="text/javascript">
    var baseImgpath = "{{ asset('storage/images') }}"
</script>
<div class="container">
    @if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
    @endif
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                	Edit Data Modul
                	<a style="float: right;" class="btn btn-primary" href="{{ route('modul.index') }}">Back</a>
            	</div>

                <div class="card-body">
                    
                   <!--  @if(@$modul->exists) <?php  $url //= route('modul.update', @$modul->id); ?>
                    @else <?php  $url //= route('modul.store'); ?>
                    @endif -->
                	<form class="form-horizontal" enctype="multipart/form-data" action="{{ route('modul.update',$modul->id)}}" method="POST" onsubmit="return getContent();" id="modulForm">
                        
                     <!--    @if (@$model->exists)
                            {{ method_field('PUT') }}
                        @else
                            {{ method_field('POST') }}
                        @endif
 -->
                        {{ csrf_field() }}
                        {{ method_field('PUT')}}

                        <!-- <div class="form-group{{ $errors->has('nomor') ? ' has-error' : '' }}">
                            <label for="bab" class="col-md-4 control-label">Bab</label>

                            <div class="col-md-6">
                                <input id="bab" type="text" class="form-control" name="bab" value="{{ @$modul->bab }}" required>

                                @if ($errors->has('bab'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('bab') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div> -->

                        <div class="form-group{{ $errors->has('judul') ? ' has-error' : '' }}">
                            <label for="judul" class="col-md-4 control-label">Judul</label>

                            <div class="col-md-6">
                                <input id="judul" type="text" class="form-control" name="judul" value="{{ @$modul->judul }}" required>

                                @if ($errors->has('judul'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('judul') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>
                        
                        <div class="form-group{{ $errors->has('sumber') ? ' has-error' : '' }}">
                            <label for="sumber" class="col-md-4 control-label">Sumber</label>

                            <div class="col-md-6">
                                <input id="sumber" type="text" class="form-control" name="sumber" value="{{ @$modul->sumber }}" required>

                                @if ($errors->has('sumber'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('sumber') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                    
                        <div class="col-md-12 row" id="dynamic-document">
                                @foreach($gambar as $key => $gmbr)
                                
                        <div class="col-md-4 gmbr-{{$key}}">
                                    
                        <input type="hidden" name="filename[]" class="new-value-{{$key}}" value="{{str_replace('public/images/','',$gmbr->nama_file)}}">
                                        <img src="{{env('APP_URL').'/storage/app'}}/{{$gmbr->nama_file}}" width="200px"> 
                                        
                                </div>
                                <div class="col-md-4 gmbr-{{$key}}">

                                        <div class="form-group">
    
                                                <div class="input-group">
                                                    <div class="input-group-prepend">
                                                        <div class="custom-file" id="edit_file"> 
                                                        <input type="file" name="file[]" class="custom-file-input  change-{{$key}}" id="customFileLang"   onchange="chooseValue({{$key}})"lang="en">
                                                        <label class="custom-file-label label-change-{{$key}}" for="customFileLang"></label>          
                                                        </div>
            
                                                    </div>
                                                </div>
                                            </div>
                                </div>
                            <div class="col-md-4 gmbr-{{$key}}">
                                    @if($key==0)
                                        <button type="button" class="btn btn-info" id="add-document"><i class="fa fa-plus"></i></button>
                                     @else
                                        <button type="button" class="btn btn-danger btn_remove" id="{{$key}}" value="{{$gmbr->id}}">x</button>
                                    @endif
                                    
                                </div>
                                @endforeach
                                
                            </div>
                            <br>
                            <br>

                        <div class="konten-cont col-lg-12 {{ $errors->has('konten') ? ' has-error' : '' }}">
                            <div class="editor-wrap">
                                <textarea id="editor1" style="display:none" name="konten" class="text-md-left" contenteditable="true">{!! $modul->konten !!}></textarea>
                            </div>
                            @if ($errors->has('sumber'))
                                <span class="help-block">
                                    <strong>{{ $errors->first('sumber') }}</strong>
                                </span>
                            @endif
                        </div>
                       

                        <div class="row">
                            <div class="col-lg-12">
                                <div class="form-group float-right">
                                    <button type="submit" class="btn btn-primary">Update
                                        <span class="btn-inner--icon"><i class="ni ni-check-bold"></i></span>
                                        <!--    @if (@$modul->exists)
                                                   Update 
                                                @else
                                                    Add 
                                                @endif -->
                                    </button>
                                    <input type='hidden' name='_token' value='{{ csrf_token() }}'>
                                    <input type="hidden" id="count" value="{{$gambar->count()}}">
                                </div>
                            </div>
                        </div>

                    
                        {{-- <div class="form-group">
                            <div class="col-md-8 col-md-offset-4">
                                <button type="submit" class="btn btn-primary"> Update
                                  <!--   @if (@$modul->exists)
                                        Update 
                                    @else
                                        Add 
                                    @endif -->
                                </button>
                                 {{ csrf_field() }}
                            </div>
                        </div> --}}
                    </form>
                    
                </div>
            </div>
        </div>
    </div>
</div>

@section('script')
    <script>
        CKEDITOR.replace( 'editor1' );
    </script>
    <script>
     function addFile() {
            var i =$("#count").val();
            $('#add-document').click(function(){
                i++;
                $('#dynamic-document').append('<div class="col-md-4 gmbr-'+i+'"></div><div class="col-md-4 gmbr-'+i+'"><div class="form-group"><div class="input-group"><div class="input-group-prepend"><div class="custom-file" id="edit_file"> <input type="file" name="file[]" class="custom-file-input change-'+(i)+'"  onchange="chooseValue('+(i)+')" id="customFileLang" lang="en"><label class="custom-file-label label-change-'+(i)+'" for="customFileLang"></label></div></div></div></div></div><div class="col-md-4 gmbr-'+i+'"><button type="button" class="btn btn-danger btn_remove" id="'+i+'">x</button></div>');
            });
            $(document).on('click', '.btn_remove', function(){
                var button_id = $(this).attr("id");
                var keys=$(this).attr("value");
                var csrfParam = '_token';
                csrfToken = $('input[name='+csrfParam+']').val();
                $.ajax({
                    type: "POST",
                    headers: {
                        'X-CSRF-TOKEN': csrfToken
                    },
                    url: "{{url('moduls/delete-gambar/')}}/"+keys+"",
                    success: function(){
                    }
                });
                $('.gmbr-'+button_id+'').remove();
                i--;
            });
        }

        $(document).ready(function () {

            addFile();
        
        })
    
    
    </script>
    <script>
     function chooseValue(i){
            var fileName=$('.change-'+i).val()
            fileName=fileName.substring(fileName.lastIndexOf("\\")+1,fileName.length)
            $(".label-change-"+i).html(fileName)
            $(".new-value-"+i).val(fileName)

        }
    </script>
@endsection

@endsection

resources/views/admin/modul/form.blade.php
@extends('partials._design')

@section('content')
<script type="text/javascript">
    var baseImgpath = "{{ asset('storage/images') }}"
</script>
<div class="container" id="modul-content">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                	Add Data Modul
                	<a style="float: right;" class="btn btn-primary" href="{{ route('modul.index') }}">Back</a>
            	</div>

                <div class="card-body">
                    
                   <!--  @if(@$modul->exists) <?php  $url //= route('modul.update', @$modul->id); ?>
                    @else <?php  $url //= route('modul.store'); ?>
                    @endif -->
                	<form class="form-horizontal" action="{{ route('modul.store') }}" method="POST" enctype="multipart/form-data" onsubmit="return getContent();" id="modulForm">
                        
                      <!--   @if (@$model->exists)
                            {{ method_field('PUT') }}
                        @else
                            {{ method_field('POST') }}
                        @endif
 -->
                        {{ csrf_field() }}

                        <!-- <div class="form-group{{ $errors->has('nomor') ? ' has-error' : '' }}">
                            <label for="bab" class="col-md-4 control-label">Bab</label>

                            <div class="col-md-6">
                                <input id="bab" type="text" class="form-control" name="bab" value="{{ @$modul->bab }}" required>

                                @if ($errors->has('bab'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('bab') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div> -->

                        <div class="form-group{{ $errors->has('judul') ? ' has-error' : '' }}">
                            <label for="judul" class="col-md-4 control-label">Judul</label>

                            <div class="col-md-6">
                                <input id="judul" type="text" class="form-control" name="judul" value="{{ @$modul->judul }}" required>

                                @if ($errors->has('judul'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('judul') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>
                        
                        <div class="form-group{{ $errors->has('sumber') ? ' has-error' : '' }}">
                            <label for="sumber" class="col-md-4 control-label">Sumber</label>

                            <div class="col-md-6">
                                <input id="sumber" type="text" class="form-control" name="sumber" value="{{ @$modul->sumber }}" required>

                                @if ($errors->has('sumber'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('sumber') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>
                        
                        <div class="form-group{{ $errors->has('konten') ? ' has-error' : '' }}">
                            <label for="konten" class="col-md-4 control-label">Konten</label>                   
                            <div class="col-lg-12">
                                <textarea class="form-control" rows="8" id="editor1" name="konten"></textarea>

                                @if ($errors->has('konten'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('konten') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-12" id="uploadgambar">
                                <div class="form-group">
                                    <label class="form-control-label" for="gambar">Tambah File Gambar</label>
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <div class="custom-file">
                                                <input type="file" name="file[]" class="custom-file-input change-1" id="customFileLang" onchange="chooseValue(1)" lang="en">
                                                <label class="custom-file-label label-change-1" for="customFileLang">Pilih Gambar</label>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-lg-12">
                                <div class="form-group float-right">
                                    <button class="btn btn-icon btn-info" type="button" id="add_button">
                                        <span class="btn-inner--icon"><i class="ni ni-fat-add"></i></span>
                                        <span class="btn-inner--text">Tambah Gambar</span>
                                    </button>
                                    <button type="submit" class="btn btn-primary">Submit
                                            <span class="btn-inner--icon"><i class="ni ni-check-bold"></i></span>
                                        <!--  @if (@$modul->exists)
                                             Update 
                                         @else
                                             Add 
                                         @endif -->
                                     </button>
                                     {{csrf_field()}}
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@section('script')
    <script type="application/javascript">
        $(document).ready(function () {
            var i=0
            $('#add_button').on('click',function () {
                i++
                $('#uploadgambar').append('<div class="form-group">\n' +
                    '    <div class="input-group">\n' +
                    '        <div class="input-group-prepend">\n' +
                    '            <div class="custom-file">\n' +
                    '                <input type="file" name="file[]" class="custom-file-input change-'+(i+1)+'" onchange="chooseValue('+(i+1)+')"  lang="en">\n' +
                    '                <label class="custom-file-label label-change-'+(i+1)+'" for="customFileLang">Tambah Gambar</label>' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '    </div>\n' +
                    '</div>');
            })
        })
    </script>
    <script>
        function chooseValue(i){
            var fileName=$('.change-'+i).val()
            fileName=fileName.substring(fileName.lastIndexOf("\\")+1,fileName.length)
            $(".label-change-"+i).html(fileName)

        }
    </script>
        
@endsection

@endsection

resources/views/admin/modul/list.blade.php
@extends('partials._design')
@section('content')
<div class="container-fluid mt-4">
    <div class="row">
        <div class="col">
            <div class="card">
                <!-- Card header -->
                <div class="card-header">
					Data Moduls
						<a style="float: right;" class="btn btn-primary" onclick="location.href='{{ route('modul.create') }}'">Add</a>
                </div>
                <div class="table-responsive py-4">

					@if(Session::has('alert-success'))
		                <div class="alert alert-success">
		                    <strong>{{ \Illuminate\Support\Facades\Session::get('alert-success') }}</strong>
		                </div>
		            @endif

                    <table class="table table-flush" id="datatable-basic">
                        <thead class="thead-light">
                            <tr>
								<th>No</th>
								<th>Judul</th>
								<th>Sumber</th>
								<th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
							@php $no = 1; @endphp
							@foreach ($modul as $item)
								<tr>
									<td>{{ $no++ }}</td>
									<td>{{ $item->judul }}</td>
									<td>{{ $item->sumber }}</td>
									<td>
										<form action="{{ route('modul.destroy', $item->id) }}" method="post">
										{{ csrf_field() }}
										{{ method_field('DELETE') }}
										<a class="btn btn-sm btn-info" href="{{ route('modul.edit', $item->id) }}">Edit</a>
										<button class="btn btn-sm btn-danger" type="submit" onclick="return confirm('Yakin ingin menghapus data?')">Delete</button>
										</form>
									</td>
								</tr>
							@endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection